tests: vsock: Use VMADDR_CID_LOCAL for loopback testing.
[nbdkit/ericb.git] / tests / test-foreground.sh
blob7dbe4a4134aa5f70450922f7054ae8eb4b0a8d79
1 #!/usr/bin/env bash
2 # nbdkit
3 # Copyright (C) 2014 Red Hat Inc.
5 # Redistribution and use in source and binary forms, with or without
6 # modification, are permitted provided that the following conditions are
7 # met:
9 # * Redistributions of source code must retain the above copyright
10 # notice, this list of conditions and the following disclaimer.
12 # * Redistributions in binary form must reproduce the above copyright
13 # notice, this list of conditions and the following disclaimer in the
14 # documentation and/or other materials provided with the distribution.
16 # * Neither the name of Red Hat nor the names of its contributors may be
17 # used to endorse or promote products derived from this software without
18 # specific prior written permission.
20 # THIS SOFTWARE IS PROVIDED BY RED HAT AND CONTRIBUTORS ''AS IS'' AND
21 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
22 # THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
23 # PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL RED HAT OR
24 # CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
25 # SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
26 # LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
27 # USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
28 # ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
29 # OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
30 # OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
31 # SUCH DAMAGE.
33 set -e
34 set -x
35 source ./functions.sh
37 # Test nbdkit -f option.
39 sock=`mktemp -u`
40 files="foreground.pid $sock"
41 rm -f $files
42 cleanup_fn rm -f $files
44 nbdkit -f -P foreground.pid -U $sock example1 &
45 bg_pid=$!
47 # We may have to wait a short time for the pid file to appear.
48 for i in {1..60}; do
49 if test -f foreground.pid; then
50 break
52 sleep 1
53 done
54 if ! test -f foreground.pid; then
55 echo "$0: PID file was not created"
56 exit 1
59 pid="$(cat foreground.pid)"
60 cleanup_fn kill $pid
62 test "$bg_pid" -eq "$pid"
64 # Check the socket was created (and is a socket).
65 test -S $sock
67 # Kill the process.
68 kill $pid
70 # Check the process exits (eventually).
71 for i in {1..10}; do
72 if ! kill -s 0 $pid; then
73 break;
75 sleep 1
76 done
77 if kill -s 0 $pid; then
78 echo "$0: process did not exit after sending a signal"
79 exit 1